import layout, response, sys
from Ft.Xml import EMPTY_NAMESPACE as no_ns
from Ft.Xml.Domlette import NoExtDtdReader, EntityReader, Print
source_base = 'file:///home/siemer/public_html/gdomain/'

class layout(layout.Layout):
    def response(self):
        doc = NoExtDtdReader.parseUri(source_base + 'gallery.xml')
        # customize template
        for attr in doc.xpath('//@*[name() = "src" or name() = "href"]'):
            attr.value = self.ln.rootRef + self.container.rootRef+ attr.value
        gnode = doc.xpath('//*[@id="galleries"]')
        pnode = doc.xpath('//*[@id="pictures"]')
        if not gnode or not pnode:
            response.error(response.NOTFOUND, 'Template is missing id(s).')
        gnode, pnode = gnode[0], pnode[0]
        for node in gnode, pnode:
            while node.hasChildNodes():
                node.removeChild(node.firstChild)
        for gallery in self.container:
            if gallery == self.container.localgallery:
                frag = EntityReader.parseString(gallery.title()+'<dummy/>')
                frag.removeChild(frag.lastChild)
                frag.lastChild.data = frag.lastChild.data[:-1]
                for a in frag.xpath('a'):
                    frag.replaceChild(a.firstChild, a)
                title = doc.xpath('/html/head/title')[0]
                title.replaceChild(frag, title.firstChild)
                
                for image in gallery[self.position.slice]:
                    image.modify(self.imageArguments)
                    img = doc.createElementNS(no_ns, 'img')
                    img.setAttributeNS(no_ns, 'alt', 'Photo')
                    img.setAttributeNS(no_ns, 'title', image.persons())
                    img.setAttributeNS(no_ns, 'src',self.ln.imageSource(image))
                    if self.ln.down:
                        a = doc.createElementNS(no_ns, 'a')
                        a.setAttributeNS(no_ns,'href',self.ln.imageDown(image))
                        a.appendChild(img)
                        root = a
                    else:
                        root = img
                    pnode.appendChild(root)
                    pnode.appendChild(doc.createTextNode('\n'))
            else:
                g=self.ln.galleryDown(gallery.path[len(self.container.path):])
                frag = EntityReader.parseString(gallery.title()+'<dummy/>')
                frag.removeChild(frag.lastChild)
                frag.lastChild.data = frag.lastChild.data[:-1]
                a = frag.xpath('a')
                if a:
                    a = a[0]
                else:
                    a = doc.createElementNS(no_ns, 'a')
                    a.appendChild(frag)
                    frag = a
                a.setAttributeNS(no_ns, 'href', g)
                li = doc.createElementNS(no_ns, 'li')
                li.appendChild(frag)
                #li.appendChild(gal.title_node(glist.ownerDocument))
                gnode.appendChild(li)
                gnode.appendChild(doc.createTextNode('\n'))

                #        style=reader.fromUri('SimplePresenter.xslt')
                #        processor=xml.xslt.Processor()
                #        processor.appendStylesheet(style)
                #        print processor.run(doc)
                
        if not gnode.hasChildNodes():
            gnode.parentNode.removeChild(gnode)
        html = doc.xpath('//html')[0]
        if self.ln.type == 'xhtml':
            response.content('application/xhtml+xml')
            html.setAttributeNS('http://www.w3.org/2000/xmlns/', 'xmlns',
                                'http://www.w3.org/1999/xhtml')
	    html.setAttributeNS("http://www.w3.org/XML/1998/namespace",
	    			'xml:lang', 'de')
            h = 0
        else:
            response.content('text/html')
	    html.setAttributeNS(no_ns, 'lang', 'de')
            h = 1
            doc.systemId = "http://www.w3.org/TR/html4/strict.dtd"
            doc.publicId = "-//W3C//DTD HTML 4.01//EN"
        Print(doc, asHtml=h)
        sys.exit()

    def normal_response(self):
        response.content('text/html')
        for gallery in self.container:
            if gallery == self.container.localgallery:
                for image in gallery[self.position.slice]:
                    image.modify(self.imageArguments)
                    if self.ln.down:
                        print '<a href="' + self.ln.imageDown(image) + '">',
                    sys.stdout.write('<img src="' +
                                     self.ln.imageSource(image) +'">')
                    if self.ln.down:
                        print '</a>'
                    else:
                        print
            else:
                g=self.ln.galleryDown(gallery.path[len(self.container.path):])
                print '<a href="' + g + '">' + g + '</a><br>'

        sys.exit()
